#include "listviewex.h"

#include <vector>
#include <map>
#include <set>

namespace listviewex{
	WNDPROC OrgListViewProc;
	//VXgr[̃vV[W
	LRESULT CALLBACK NewListViewProc(HWND hWnd,UINT msg,WPARAM wp,LPARAM lp);
	void DrawListItemText(HDC hdc,char *Text,RECT *rc,int fmt);
	typedef struct{
		HWND hCheckBox;
		int cx;
	}ItemData;
	std::map<HWND,bool> isColumnFixed;
	std::map<HWND,std::map<int,std::map<int,ItemData>>> ItemMap;
};

void ListViewEx_Init(HWND hList){
	using namespace listviewex;
	//Xgr[
	DWORD dwStyle;
	dwStyle = ListView_GetExtendedListViewStyle(hList);
    dwStyle |= LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES | LVS_OWNERDRAWFIXED;
    ListView_SetExtendedListViewStyle(hList, dwStyle);
	OrgListViewProc = (WNDPROC)(LONG_PTR)GetWindowLongPtr(hList,GWL_WNDPROC);
	SetWindowLong(hList,GWL_WNDPROC,(__int3264)(LONG_PTR)NewListViewProc);
}
void ListViewEx_ColumnFix(HWND hList,bool isFix){
	using namespace listviewex;
	//J̌Œ
	isColumnFixed[hList] = isFix;
}
void ListViewEx_OwnerDraw(LPDRAWITEMSTRUCT lpDraw){
	using namespace listviewex;
	//Xgr[I[i[h[{
	HWND hList;			//Xgr[̃nh
	HDC hdc;			//foCXReLXg
	HBRUSH hBrush;		//wiuV
	LVCOLUMN LvColumn;   //񍀖ڎ擾p̍\
	int SubItemNum;		//TuACě
	
	char Text[256];
	RECT rc,rcAll;

	hList=lpDraw->hwndItem;
	hdc = lpDraw->hDC;
	
	//foCXReLXg̕ۑ
	SaveDC(hdc);
	//̔wi̔񓧉ߐݒ
	SetBkMode(hdc,OPAQUE);
	if (lpDraw->itemState & ODS_SELECTED){//IACe̋\
		hBrush=CreateSolidBrush(GetSysColor(COLOR_HIGHLIGHT));
		SetBkColor(hdc, GetSysColor(COLOR_HIGHLIGHT));
		SetTextColor(hdc, GetSysColor(COLOR_HIGHLIGHTTEXT));
	}else{
		COLORREF Color=ListView_GetTextBkColor(hList);
		if(Color & 0xff000000) Color=GetSysColor(COLOR_WINDOW);
		hBrush=CreateSolidBrush (Color);
	}

	//wi𖄂߂
	ListView_GetItemRect(hList,lpDraw->itemID,&rcAll,LVIR_BOUNDS);
	ListView_GetItemRect(hList,lpDraw->itemID,&rc,LVIR_LABEL);
	rcAll.left=rc.left;

	ZeroMemory(&LvColumn,sizeof(LvColumn));
	LvColumn.mask=LVCF_FMT;
	//ACe̐擾
	SubItemNum=Header_GetItemCount(ListView_GetHeader(hList))-1;
	//ACe̕\
	for(int SubItem=0;SubItem<=SubItemNum;SubItem++){
		//wĩNA
		ListView_GetSubItemRect(hList,lpDraw->itemID,SubItem,LVIR_BOUNDS,&rc);	
		FillRect(hdc,&rc,hBrush);
		//񍀖ڂ̃tH[}bg̎擾
		ListView_GetColumn(hList,SubItem,&LvColumn);
		ListView_GetSubItemRect(hList,lpDraw->itemID,SubItem,LVIR_LABEL,&rc);
		//ACȅ̎擾
		ListView_GetItemText(hList,lpDraw->itemID,SubItem,Text,sizeof(Text));
		//`FbN{bNX\
		ItemData cdata = ItemMap[hList][lpDraw->itemID][SubItem];
		rc.left += cdata.cx;
		if(cdata.hCheckBox!=NULL){
			MoveWindow(cdata.hCheckBox,rc.left,rc.top+2,12,12,TRUE);
			rc.left+=12;
		}
		DrawListItemText(hdc,Text,&rc,LvColumn.fmt);
	}

	if (lpDraw->itemState & ODS_FOCUS){
		DrawFocusRect(hdc,&rcAll);
	}

	//uV̍폜
	DeleteObject(hBrush);
	//foCXReLXg̕
	RestoreDC(hdc,-1);
}
void listviewex::DrawListItemText(HDC hdc,char *Text,RECT *rc,int fmt){
	using namespace listviewex;
	DRAWTEXTPARAMS  DrawTextExParam;
	int style;

	//}[Wݒ
	DrawTextExParam.cbSize=sizeof(DrawTextExParam);
	DrawTextExParam.iLeftMargin=2;
	DrawTextExParam.iRightMargin=0;
	DrawTextExParam.iTabLength=0;
	DrawTextExParam.uiLengthDrawn=0;

	//̔zuDrawTextExpɕϊ
	if((fmt & LVCFMT_JUSTIFYMASK)==LVCFMT_LEFT){
		style=DT_LEFT;
	}else if((fmt & LVCFMT_JUSTIFYMASK)==LVCFMT_RIGHT){
		style=DT_RIGHT;
		DrawTextExParam.iRightMargin=6;
	}
	else style=DT_CENTER;
	//̕\
	DrawTextEx(hdc,Text, lstrlen(Text),rc,
		style | DT_VCENTER | DT_SINGLELINE | DT_END_ELLIPSIS,
		&DrawTextExParam);
}

LRESULT CALLBACK listviewex::NewListViewProc(HWND hWnd,UINT msg,WPARAM wp,LPARAM lp){
	//VXgr[̃vV[W
	switch (msg){
		case WM_COMMAND:{
			SendMessage((HWND)lp,BM_SETCHECK,!SendMessage((HWND)lp,BM_GETCHECK,0,0),0);
			NMHDR nmhdr;
			//Xgr[̐ẽvV[WLVN_CHECKCHANGEDbZ[W𑗂
			ZeroMemory(&nmhdr,sizeof(NMHDR));
			nmhdr.idFrom = LOWORD(wp);
			nmhdr.hwndFrom = hWnd;
			nmhdr.code = LVN_CHECKCHANGED;
			SendMessage(GetParent(hWnd),WM_NOTIFY,LOWORD(wp),(LPARAM)&nmhdr);
						}
			return 0;
		case WM_NOTIFY:
			if(isColumnFixed[hWnd]==true){
				switch(((NMHDR*)lp)->code ) {
					case HDN_BEGINTRACKA:
					case HDN_BEGINTRACKW:
					case HDN_DIVIDERDBLCLICKA:
					case HDN_DIVIDERDBLCLICKW:
					return TRUE;
				}
			}
			break;
	}

	return CallWindowProc((WNDPROC)OrgListViewProc,hWnd,msg,wp,lp);
}

void ListViewEx_SetColumnString(HWND hWnd,int iCol,int cx,LPSTR str){
	using namespace listviewex;
	//̒ǉ
	LV_COLUMN listcol;
	listcol.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
	listcol.fmt = LVCFMT_LEFT;
	listcol.cx = cx;
	listcol.pszText = (LPSTR)str;
	listcol.iSubItem = iCol;
	ListView_InsertColumn(hWnd,iCol,&listcol);
}
void ListViewEx_SetItemString(HWND hWnd,int iItem,int iSubItem,int cx,LPSTR str,BOOL checkbox){
	using namespace listviewex;
	//ACe̒ǉ
	int max = ListView_GetItemCount(hWnd);
	if(max<=iItem){
		LV_ITEM item;
		ZeroMemory(&item,sizeof(LV_ITEM));
		item.mask = LVIF_TEXT;
		for(int i=max;i<=iItem;i++){
			item.iItem = i;
			ListView_InsertItem(hWnd,&item);
		}
	}
	ItemMap[hWnd][iItem][iSubItem].cx = cx;
	ListView_SetItemText(hWnd,iItem,iSubItem,str);
	if(checkbox){
		HINSTANCE hInst = (HINSTANCE)(LONG_PTR)GetWindowLong(hWnd, GWL_HINSTANCE);
		HWND hc = CreateWindow(TEXT("BUTTON") ,NULL,
				WS_CHILD | WS_VISIBLE | BS_CHECKBOX,
				0,0,12,12,
				hWnd,NULL,hInst,NULL);
		ItemMap[hWnd][iItem][iSubItem].hCheckBox=hc;
	}else{
		DestroyWindow(ItemMap[hWnd][iItem][iSubItem].hCheckBox);
		if(cx==0){
			ItemMap[hWnd][iItem].erase(ItemMap[hWnd][iItem].find(iSubItem));
			if(ItemMap[hWnd][iItem].size()==0){
				ItemMap[hWnd].erase(ItemMap[hWnd].find(iItem));
			}
		}
	}
}
void ListViewEx_DeleteAllItems(HWND hList){
	using namespace listviewex;
	//ׂẴACe̍폜
	ListView_DeleteAllItems(hList);
	std::map<int,std::map<int,ItemData>>::iterator cbit = ItemMap[hList].begin();
	while(cbit!=ItemMap[hList].end()){
		std::map<int,ItemData>::iterator cbit2 = cbit->second.begin();
		while(cbit2!=cbit->second.end()){
			DestroyWindow(cbit2->second.hCheckBox);
			cbit2++;
		}
		cbit->second.clear();
		cbit++;
	}
	ItemMap[hList].clear();
}

BOOL ListViewEx_GetCheckState(HWND hList,int iItem,int iSubItem){
	using namespace listviewex;
	//`FbN{bNX̏Ԏ擾
	return Button_GetCheck(ItemMap[hList][iItem][iSubItem].hCheckBox);
}
void ListViewEx_SetCheckState(HWND hList,int iItem,int iSubItem,BOOL check){
	using namespace listviewex;
	//`FbN{bNX̏Ԑݒ
	Button_SetCheck(ItemMap[hList][iItem][iSubItem].hCheckBox,check);
}
void ListViewEx_CheckEnable(HWND hList,int iItem,int iSubItem,BOOL fEnable){
	using namespace listviewex;
	Button_Enable(ItemMap[hList][iItem][iSubItem].hCheckBox,fEnable);
}